﻿using System.Web.Mvc;
using MVCSampleBrowser.Models;
using SyncfusionMvcApplication40.Grid;
using Syncfusion.XlsIO;
using Syncfusion.EJ.Export;
using System.Linq;
using Syncfusion.JavaScript.Models;
using System.Collections.Generic;
using System.Web.Script.Serialization;
using System.Collections;
using System;
using System.Reflection;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript;
using System.Net;

namespace SyncfusionMvcApplication40.Controllers
{
    public class GridController : Controller
    {
      // public static List<Orders> order = new List<Orders>();
        public ActionResult GridFeatures()
        {
            var DataSource = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.datasource = DataSource;
            return View();
        }
        public ActionResult UrlDataSource(DataManager dm)
        {

            IEnumerable DataSource = OrderRepository.GetAllRecords();
            DataOperations ds = new DataOperations();
            List<string> str = new List<string>();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = ds.PerformSearching(DataSource, dm.Search);
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = ds.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = ds.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
            }
            if (dm.Aggregates != null)
            {
                for (var i = 0; i < dm.Aggregates.Count; i++)
                    str.Add(dm.Aggregates[i].Field);

            }
            IEnumerable aggregate = ds.PerformSelect(DataSource, str);
            var count = DataSource.Cast<EditableOrder>().Count();
            DataSource = ds.PerformSkip(DataSource, dm.Skip);
            DataSource = ds.PerformTake(DataSource, dm.Take);
            return Json(new { result = DataSource, count = count, aggregate = aggregate });
        }
        //public ActionResult PerformUpdate(EditableOrder value)
        //{
        //    OrderRepository.Update(value);
        //    var data = OrderRepository.GetAllRecords();
        //    return Json(data, JsonRequestBehavior.AllowGet);
        //}
        public ActionResult PerformUpdate(EditableOrder value)
        {
            if (value.OrderID > 300) // check some condition and process update action 
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, "Data is not valid"); //message returns the exception content 
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        //public ActionResult PerformInsert(EditableOrder value)
        //{
        //    OrderRepository.Add(value);
        //    var data = OrderRepository.GetAllRecords();
        //    return Json(data, JsonRequestBehavior.AllowGet);
        //}
        public ActionResult PerformInsert(EditableOrder value)
        {
            if (!ModelState.IsValid) //if validation got failed
            {
                var message = string.Join(" | ", ModelState.Values
       .SelectMany(v => v.Errors)
       .Select(e => e.ErrorMessage));
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, message);//message returns the exception content 
            }
            OrderRepository.Add(value);
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public ActionResult PerformDelete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }

    }
}